pmarlen-webrf3/src/main/java/com/pmarlen/web/operation/NavigationMB.java
package com.pmarlen.web.operation;

import com.pmarlen.web.security.managedbean.SessionUserMB;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Locale;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.component.UIViewRoot;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.richfaces.component.html.HtmlPanelMenu;
import org.richfaces.component.html.HtmlPanelMenuGroup;
import org.richfaces.component.html.HtmlPanelMenuItem;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 *
 * @author alfredo
 */
public class NavigationMB {
	
	private LineaMB lineaMB;
	private IndustriaMB industriaMB;
	private MarcaMB marcaMB;
	private ProductoMB productoMB;
	private UsuarioMB  usuarioMB;
	private ClienteMB  clienteMB;
	private ProveedorMB  proveedorMB;
	private SucursalMB  sucursalMB;	
	private PedidosPreVisorMB pedidosPreVisorMB;
	private VerPedidoEnProcesoMB verPedidoEnProcesoMB;	
	private static final Logger logger = LoggerFactory.getLogger(NavigationMB.class);
	private Boolean renderedForMobile;
	private static HtmlPanelMenu htmlPanelMenu;
	private SessionUserMB sessionUserMB;
	private PedidosVentasViewMB pedidosVentasViewMB;
	private InventariosViewMB inventariosViewMB;
	private GaleriaProductosMB galeriaProductosMB;

	private CompraMB compraMB;
	
	public NavigationMB() {
	}

	public Locale getLocale() {
		FacesContext context = FacesContext.getCurrentInstance();
		return getLocale(context);
	}
	private List<Locale> supportedLocales;

	public void setSessionUserMB(SessionUserMB sessionUserMB) {
		this.sessionUserMB = sessionUserMB;
	}
	
	public void setLineaMB(LineaMB lineaMB) {
		this.lineaMB = lineaMB;
	}

	public void setIndustriaMB(IndustriaMB industriaMB) {
		this.industriaMB = industriaMB;
	}

	public void setMarcaMB(MarcaMB marcaMB) {
		this.marcaMB = marcaMB;
	}

	public void setProductoMB(ProductoMB productoMB) {
		this.productoMB = productoMB;
	}

	public void setUsuarioMB(UsuarioMB usuarioMB) {
		this.usuarioMB = usuarioMB;
	}

	public void setClienteMB(ClienteMB clienteMB) {
		this.clienteMB = clienteMB;
	}

	public void setProveedorMB(ProveedorMB proveedorMB) {
		this.proveedorMB = proveedorMB;
	}

	public void setSucursalMB(SucursalMB sucursalMB) {
		this.sucursalMB = sucursalMB;
	}

	public void setPedidosPreVisorMB(PedidosPreVisorMB pedidosPreVisorMB) {
		this.pedidosPreVisorMB = pedidosPreVisorMB;
	}
	
	public void setVerPedidoEnProcesoMB(VerPedidoEnProcesoMB verPedidoEnProcesoMB) {
		this.verPedidoEnProcesoMB = verPedidoEnProcesoMB;
	}

	public void setPedidosVentasViewMB(PedidosVentasViewMB pedidosVentasViewMB) {
		this.pedidosVentasViewMB = pedidosVentasViewMB;
	}

	public void setInventariosViewMB(InventariosViewMB inventariosViewMB) {
		this.inventariosViewMB = inventariosViewMB;
	}

	public void setGaleriaProductosMB(GaleriaProductosMB galeriaProductosMB) {
		this.galeriaProductosMB = galeriaProductosMB;
	}
	
	public void setCompraMB(CompraMB compraMB) {
		this.compraMB = compraMB;
	}
	
	
	public List<Locale> getSupportedLocales() {
		//logger.trace("->getSupportedLocales:");
		if (supportedLocales == null) {
			supportedLocales = new ArrayList<Locale>();
			logger.trace("\t creating supportedLocales list.");

			FacesContext context = FacesContext.getCurrentInstance();
			Application app = context.getApplication();

			final Iterator<Locale> sli = app.getSupportedLocales();
			while (sli.hasNext()) {
				Locale l = sli.next();
				supportedLocales.add(l);
				//logger.trace("\t\t->add local:" + l);
			}
		}
		//logger.trace("->getSupportedLocales: supportedLocales=" + supportedLocales);

		return supportedLocales;
	}

	public String changeLocale() {
		FacesContext context = FacesContext.getCurrentInstance();
		Application app = context.getApplication();

		String localeToChange = context.getExternalContext().getRequestParameterMap().get("localeToChange");

		logger.trace("->changeLocale: localeToChange=" + localeToChange);

		final Iterator<Locale> sli = app.getSupportedLocales();
		while (sli.hasNext()) {
			Locale l = sli.next();
			if (l.toString().equals(localeToChange)) {
				setLocale(context, l);
				logger.trace("\tOk found, changing Locale to :" + l);
				break;
			}
		}
		return null;
	}

	public String getLocaleInfo() {
		FacesContext context = FacesContext.getCurrentInstance();

		Application app = context.getApplication();
		String appBundle = app.getMessageBundle();
		Locale locale = getLocale(context);
		final Iterator<Locale> supportedLocales = app.getSupportedLocales();
		StringBuffer sb = new StringBuffer("{");
		int nl = 0;
		while (supportedLocales.hasNext()) {
			Locale l = supportedLocales.next();
			if (nl > 0) {
				sb.append(", ");

			}
			if (locale.equals(l)) {
				sb.append("*");
			}
			sb.append(l.toString());
			nl++;
		}
		sb.append("}");

		return sb.toString();
	}

	public static Locale getLocale(FacesContext context) {
		Locale locale = null;
		UIViewRoot viewRoot = context.getViewRoot();
		if (viewRoot != null) {
			locale = viewRoot.getLocale();
		}
		if (locale == null) {
			locale = Locale.getDefault();
		}
		return locale;
	}

	public static void setLocale(FacesContext context, Locale locale) {

		UIViewRoot viewRoot = context.getViewRoot();
		if (viewRoot != null) {
			viewRoot.setLocale(locale);
		}

	}

	public boolean getRenderedForMobile() {
		if (renderedForMobile == null) {
			ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
			String userAgent = externalContext.getRequestHeaderMap().get("User-Agent");
			final boolean androidOperaMiniTest = userAgent.toLowerCase().contains("android") && (userAgent.toLowerCase().contains("opera mini")||userAgent.toLowerCase().contains("like gecko"));
			renderedForMobile = androidOperaMiniTest;
			logger.trace("==>>renderedForMobile=" + renderedForMobile);
		}
		return renderedForMobile.booleanValue();
	}

	public int getNumColumnsLiteral() {
		int nc = -1;
		if (getRenderedForMobile()) {
			nc = 2;
		} else {
			nc = 1;
		}
		return nc;
	}

	public String getColumnClassLiteral() {
		String s = null;

		if (getRenderedForMobile()) {
			s = "columnWidth20 leftAlign topAlign,columnWidth80 centerAlign topAlign";
		} else {
			s = "centerAlign topAlign";
		}
		return s;
	}
	/*
	 public boolean getUseMenuBarLayout(){
	 ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
	 String userAgent = externalContext.getRequestHeaderMap().get("User-Agent");
	 return !userAgent.toLowerCase().contains("android");
	 }	
	
	 public boolean getUsePanelMenuLayout(){
	 ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
	 String userAgent = externalContext.getRequestHeaderMap().get("User-Agent");
		
	 return userAgent.toLowerCase().contains("android");
	 }
	 */

	public String home() {
		sessionUserMB.updateLastVisitedPage("home");
		return "home";
	}

	//--------------------------------------------
	public String swapMenuStyle() {
		logger.debug("===>>swapMenuStyle:renderedForMobile=" + renderedForMobile);
		renderedForMobile = !renderedForMobile;
		logger.debug("\t===>>renderedForMobile=" + renderedForMobile);
		return null;
	}

	//--------------------------------------------
	
	public String cambiarModoVenta() {
		sessionUserMB.updateLastVisitedPage("cambiarModoVenta");
		return "cambiarModoVenta";
	}

	public String verProductosXLineaMarca() {
		sessionUserMB.updateLastVisitedPage("verProductosXLineaMarca");
		return "verProductosXLineaMarca";
	}

	public String verProductosXIndustriaMarca() {
		sessionUserMB.updateLastVisitedPage("verProductosXIndustriaMarca");
		return "verProductosXIndustriaMarca";
	}
	

	public String pedidoSimple() {
		sessionUserMB.updateLastVisitedPage("pedidoSimple");
		return "pedidoSimple";
	}

	public String verProductosEnPedidoSimple() {
		sessionUserMB.updateLastVisitedPage("verProductosEnPedidoSimple");
		return "verProductosEnPedidoSimple";
	}

	public String listarPedidosVentas() {
		sessionUserMB.updateLastVisitedPage("listarPedidosVentas");
		pedidosPreVisorMB.reinicializarLista();
		return "listarPedidosVentas";
	}
	
	public String pedidosVentasView() {
		sessionUserMB.updateLastVisitedPage("pedidosVentasView");
		pedidosVentasViewMB.reinicializarLista();
		return "pedidosVentasView";
	}

	public String inventariosView() {
		sessionUserMB.updateLastVisitedPage("inventariosView");
		inventariosViewMB.reinicializarLista();
		return "inventariosView";
	}
	
	public String galeriaProductos() {
		sessionUserMB.updateLastVisitedPage("galeriaProductos");
		galeriaProductosMB.reinicializarLista();
		return "galeriaProductos";
	}


	public String pedidoNuevo() {
		sessionUserMB.updateLastVisitedPage("pedidoNuevo");
		return "pedidoNuevo";
	}
	
	public String compra() {
		sessionUserMB.updateLastVisitedPage("compra");
		return "compra";
	}

	public String pedidoVenta() {
		sessionUserMB.updateLastVisitedPage("pedidoVenta");
		return "pedidoVenta";
	}
	
	public String catalogoLinea() {
		sessionUserMB.updateLastVisitedPage("catalogoLinea");
		this.lineaMB.reinicializarLista();
		this.lineaMB.actualizarLista();		
		return "catalogoLinea";
	}

	public String catalogoIndustria() {
		sessionUserMB.updateLastVisitedPage("catalogoIndustria");

pmarlen-webrf3/src/main/webapp/templates/mainWithMenu.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:c="http://java.sun.com/jsp/jstl/core"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:a4j="http://richfaces.org/a4j"
      xmlns:rich="http://richfaces.org/rich">

    <head>

        <title><ui:insert name="title"/></title>		
		<ui:include src="/templates/include/dynamic-css.xhtml" />
		<link href="${facesContext.externalContext.requestContextPath}/images/Logo_icono_2.gif" rel="shortcut icon" type="image/x-icon"/>
		<link href="${facesContext.externalContext.requestContextPath}/images/Logo_icono_2.gif" rel="icon"          type="image/x-icon"/>
		<script >

		function init(){
			console.log("-->>init()");
			//timedMsg();
			document.forms[0].j_username.focus();
		}
		function timedMsg() {
			console.log("-->>timedMsg()");
			var t = setTimeout("returnToHome();",#{session.maxInactiveInterval*1000 + 10});
		}
		function returnToHome() {
			console.log("-->>returnToHome()");
			window.location = "${facesContext.externalContext.requestContextPath}";
		}

		</script>

    </head>

    <body onload="init();">	

		<h:panelGrid id="mainTemplatePanel" columns="1" class="mainBodyLayout">
			<f:facet name="header">
				<h:panelGroup>
					<ui:include src="/templates/include/header.xhtml" />
					<ui:include src="/templates/include/menuBar.xhtml" />

				</h:panelGroup>
			</f:facet>

			<h:panelGrid columns="#{navigationMB.numColumnsLiteral}" width="100%" columnClasses="#{navigationMB.columnClassLiteral}">

				<h:panelGroup rendered="#{navigationMB.renderedForMobile}" style="vertical-align: top;">
					<ui:include src="/templates/include/panelMenu.xhtml" />
				</h:panelGroup>

				<rich:panel bodyClass="body-main-panel" width="100%">

					<f:facet name="header">

						<h:panelGrid	id="panelGridBotonesPanelMenu"
									 width="100%" 
									 columns="3"
									 columnClasses="leftAlign columnWidth2, leftAlign columnWidth95">
							<a4j:status>
								<f:facet name="start">
									<h:graphicImage  value="/images/gif_loading_azul.gif"/>
								</f:facet>								
								<h:graphicImage  value="/images/png/Transparent_4x16.png"/>								
							</a4j:status>

							<h:panelGroup>
								<h:graphicImage  value="/images/png/Transparent_4x16.png"/>								
								<ui:insert name="location">
									#{UIMessages.MENU_LOCATION_PATH}
								</ui:insert>
							</h:panelGroup>
							

						</h:panelGrid>

					</f:facet>

					<ui:insert name="body">Body</ui:insert>						

				</rich:panel>

			</h:panelGrid>

			<f:facet name="footer">

				<ui:include src="/templates/include/footer.xhtml" />

			</f:facet>

		</h:panelGrid>

	</body>

</html>